/[gentoo-x86]/eclass/gnome2.eclass
Gentoo

Diff of /eclass/gnome2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.63 Revision 1.119
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/gnome2.eclass,v 1.63 2006/03/15 00:38:40 allanonjl Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/gnome2.eclass,v 1.119 2013/01/16 22:52:37 eva Exp $
4 4
5# GNOME 2 ECLASS 5# @ECLASS: gnome2.eclass
6inherit libtool gnome.org debug fdo-mime eutils 6# @MAINTAINER:
7# gnome@gentoo.org
8# @BLURB: Provides phases for Gnome/Gtk+ based packages.
9# @DESCRIPTION:
10# Exports portage base functions used by ebuilds written for packages using the
11# GNOME framework. For additional functions, see gnome2-utils.eclass.
7 12
13inherit eutils fdo-mime libtool gnome.org gnome2-utils
14
15case "${EAPI:-0}" in
16 0|1)
17 EXPORT_FUNCTIONS src_unpack src_compile src_install pkg_preinst pkg_postinst pkg_postrm
18 ;;
19 2|3|4|5)
20 EXPORT_FUNCTIONS src_unpack src_prepare src_configure src_compile src_install pkg_preinst pkg_postinst pkg_postrm
21 ;;
22 *) die "EAPI=${EAPI} is not supported" ;;
23esac
24
25# @ECLASS-VARIABLE: G2CONF
26# @DEFAULT_UNSET
27# @DESCRIPTION:
8# Extra configure opts passed to econf 28# Extra configure opts passed to econf
9G2CONF=${G2CONF:=""} 29G2CONF=${G2CONF:-""}
10 30
31# @ECLASS-VARIABLE: GNOME2_LA_PUNT
32# @DESCRIPTION:
33# Should we delete ALL the .la files?
34# NOT to be used without due consideration.
35if has ${EAPI:-0} 0 1 2 3 4; then
36 GNOME2_LA_PUNT=${GNOME2_LA_PUNT:-"no"}
37else
38 GNOME2_LA_PUNT=${GNOME2_LA_PUNT:-""}
39fi
40
41# @ECLASS-VARIABLE: ELTCONF
42# @DEFAULT_UNSET
43# @DESCRIPTION:
11# Extra options passed to elibtoolize 44# Extra options passed to elibtoolize
12ELTCONF=${ELTCONF:=""} 45ELTCONF=${ELTCONF:-""}
13 46
47# @ECLASS-VARIABLE: USE_EINSTALL
48# @DEFAULT_UNSET
49# @DESCRIPTION:
14# Should we use EINSTALL instead of DESTDIR 50# Should we use EINSTALL instead of DESTDIR. DEPRECATED
15USE_EINSTALL=${USE_EINSTALL:=""} 51USE_EINSTALL=${USE_EINSTALL:-""}
16 52
17# Run scrollkeeper for this package? 53# @ECLASS-VARIABLE: SCROLLKEEPER_UPDATE
54# @DESCRIPTION:
55# Whether to run scrollkeeper for this package or not. DEPRECATED
18SCROLLKEEPER_UPDATE=${SCROLLKEEPER_UPDATE:="1"} 56SCROLLKEEPER_UPDATE=${SCROLLKEEPER_UPDATE:-"1"}
19 57
20# Where to put scrollkeeper data lives 58# @ECLASS-VARIABLE: DOCS
21SCROLLKEEPER_DIR=${SCROLLKEEPER_DIR:="/var/lib/scrollkeeper"} 59# @DEFAULT_UNSET
60# @DESCRIPTION:
61# String containing documents passed to dodoc command.
22 62
23# Path to scrollkeeper-update 63# @ECLASS-VARIABLE: GCONF_DEBUG
24SCROLLKEEPER_UPDATE_BIN=${SCROLLKEEPER_UPDATE_BIN:="${ROOT}/usr/bin/scrollkeeper-update"} 64# @DEFAULT_UNSET
65# @DESCRIPTION:
66# Whether to handle debug or not.
67# Some gnome applications support various levels of debugging (yes, no, minimum,
68# etc), but using --disable-debug also removes g_assert which makes debugging
69# harder. This variable should be set to yes for such packages for the eclass
70# to handle it properly. It will enable minimal debug with USE=-debug.
71# Note that this is most commonly found in configure.ac as GNOME_DEBUG_CHECK.
25 72
26# Path to gconftool-2
27GCONFTOOL_BIN=${GCONFTOOL_BIN:="${ROOT}/usr/bin/gconftool-2"}
28 73
74if [[ ${GCONF_DEBUG} != "no" ]]; then
29IUSE="debug doc" 75 IUSE="debug"
76fi
30 77
31DEPEND=">=sys-apps/sed-4
32 sys-apps/findutils"
33 78
79# @FUNCTION: gnome2_src_unpack
80# @DESCRIPTION:
81# Stub function for old EAPI.
34gnome2_src_unpack() { 82gnome2_src_unpack() {
35 unpack ${A} 83 unpack ${A}
36 cd ${S} 84 cd "${S}"
85 has ${EAPI:-0} 0 1 && gnome2_src_prepare
86}
87
88# @FUNCTION: gnome2_src_prepare
89# @DESCRIPTION:
90# Prepare environment for build, fix build of scrollkeeper documentation,
91# run elibtoolize.
92gnome2_src_prepare() {
93 # Prevent assorted access violations and test failures
94 gnome2_environment_reset
37 95
38 # Prevent scrollkeeper access violations 96 # Prevent scrollkeeper access violations
39 gnome2_omf_fix 97 gnome2_omf_fix
40}
41 98
99 # Disable all deprecation warnings
100 gnome2_disable_deprecation_warning
101
102 # Run libtoolize
103 if has ${EAPI:-0} 0 1 2 3; then
104 elibtoolize ${ELTCONF}
105 else
106 # Everything is fatal EAPI 4 onwards
107 nonfatal elibtoolize ${ELTCONF}
108 fi
109
110}
111
112# @FUNCTION: gnome2_src_configure
113# @DESCRIPTION:
114# Gnome specific configure handling
42gnome2_src_configure() { 115gnome2_src_configure() {
43 # Update the GNOME configuration options 116 # Update the GNOME configuration options
44 use debug && G2CONF="${G2CONF} --enable-debug=yes" 117 if [[ ${GCONF_DEBUG} != 'no' ]] ; then
118 if use debug ; then
119 G2CONF="--enable-debug=yes ${G2CONF}"
120 fi
121 fi
122
123 # Starting with EAPI=5, we consider packages installing gtk-doc to be
124 # handled by adding DEPEND="dev-util/gtk-doc-am" which provides tools to
125 # relink URLs in documentation to already installed documentation.
126 # This decision also greatly helps with constantly broken doc generation.
127 # Remember to drop 'doc' USE flag from your package if it was only used to
128 # rebuild docs.
129 # Preserve old behavior for older EAPI.
130 if grep -q "enable-gtk-doc" ${ECONF_SOURCE:-.}/configure ; then
131 if has ${EAPI:-0} 0 1 2 3 4 && has doc ${IUSE} ; then
45 G2CONF="${G2CONF} $(use_enable doc gtk-doc)" 132 G2CONF="$(use_enable doc gtk-doc) ${G2CONF}"
133 else
134 G2CONF="--disable-gtk-doc ${G2CONF}"
135 fi
136 fi
46 137
47 # Run libtoolize 138 # Pass --disable-maintainer-mode when needed
48 elibtoolize ${ELTCONF} 139 if grep -q "^[[:space:]]*AM_MAINTAINER_MODE(\[enable\])" \
140 ${ECONF_SOURCE:-.}/configure.*; then
141 G2CONF="--disable-maintainer-mode ${G2CONF}"
142 fi
49 143
50 # GST_REGISTRY is to work around gst-inspect trying to read/write /root 144 # Pass --disable-scrollkeeper when possible
51 GST_REGISTRY="${S}/registry.xml" econf "$@" ${G2CONF} || die "configure failed" 145 if grep -q "disable-scrollkeeper" ${ECONF_SOURCE:-.}/configure; then
52} 146 G2CONF="--disable-scrollkeeper ${G2CONF}"
147 fi
53 148
149 # Pass --disable-silent-rules when possible (not needed for eapi5), bug #429308
150 if has ${EAPI:-0} 0 1 2 3 4; then
151 if grep -q "disable-silent-rules" ${ECONF_SOURCE:-.}/configure; then
152 G2CONF="--disable-silent-rules ${G2CONF}"
153 fi
154 fi
155
156 # Pass --disable-schemas-install when possible
157 if grep -q "disable-schemas-install" ${ECONF_SOURCE:-.}/configure; then
158 G2CONF="--disable-schemas-install ${G2CONF}"
159 fi
160
161 # Pass --disable-schemas-compile when possible
162 if grep -q "disable-schemas-compile" ${ECONF_SOURCE:-.}/configure; then
163 G2CONF="--disable-schemas-compile ${G2CONF}"
164 fi
165
166 # Avoid sandbox violations caused by gnome-vfs (bug #128289 and #345659)
167 addwrite "$(unset HOME; echo ~)/.gnome2"
168
169 econf ${G2CONF} "$@"
170}
171
172# @FUNCTION: gnome2_src_compile
173# @DESCRIPTION:
174# Stub function for old EAPI.
54gnome2_src_compile() { 175gnome2_src_compile() {
55 gnome2_src_configure "$@" 176 has ${EAPI:-0} 0 1 && gnome2_src_configure "$@"
56 emake || die "compile failure" 177 emake || die "compile failure"
57} 178}
58 179
180# @FUNCTION: gnome2_src_install
181# @DESCRIPTION:
182# Gnome specific install. Handles typical GConf and scrollkeeper setup
183# in packages and removal of .la files if requested
59gnome2_src_install() { 184gnome2_src_install() {
185 has ${EAPI:-0} 0 1 2 && ! use prefix && ED="${D}"
60 # if this is not present, scrollkeeper-update may segfault and 186 # if this is not present, scrollkeeper-update may segfault and
61 # create bogus directories in /var/lib/ 187 # create bogus directories in /var/lib/
62 dodir "${SCROLLKEEPER_DIR}" 188 local sk_tmp_dir="/var/lib/scrollkeeper"
189 dodir "${sk_tmp_dir}" || die "dodir failed"
63 190
64 # we must delay gconf schema installation due to sandbox 191 # we must delay gconf schema installation due to sandbox
65 export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL="1" 192 export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL="1"
66 193
67 debug-print "You are testing with DESTDIR by default - AllanonJL"
68 if [[ -z "${USE_EINSTALL}" || "${USE_EINSTALL}" = "0" ]]; then 194 if [[ -z "${USE_EINSTALL}" || "${USE_EINSTALL}" = "0" ]]; then
69 make DESTDIR=${D} "$@" install || die "install failed" 195 debug-print "Installing with 'make install'"
196 emake DESTDIR="${D}" "scrollkeeper_localstate_dir=${ED}${sk_tmp_dir} " "$@" install || die "install failed"
70 else 197 else
198 debug-print "Installing with 'einstall'"
71 einstall "scrollkeeper_localstate_dir=${D}${SCROLLKEEPER_DIR} " "$@" || die "einstall failed" 199 einstall "scrollkeeper_localstate_dir=${ED}${sk_tmp_dir} " "$@" || die "einstall failed"
72 fi 200 fi
73 201
74 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL 202 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
75 203
204 # Handle documentation as 'default' for eapi5 and newer, bug #373131
205 if has ${EAPI:-0} 0 1 2 3 4; then
76 # Manual document installation 206 # Manual document installation
207 if [[ -n "${DOCS}" ]]; then
208 dodoc ${DOCS} || die "dodoc failed"
209 fi
210 else
211 if ! declare -p DOCS >/dev/null 2>&1 ; then
212 local d
213 for d in README* ChangeLog AUTHORS NEWS TODO CHANGES THANKS BUGS \
214 FAQ CREDITS CHANGELOG ; do
77 [[ -n "${DOCS}" ]] && dodoc ${DOCS} 215 [[ -s "${d}" ]] && dodoc "${d}"
216 done
217 elif declare -p DOCS | grep -q '^declare -a' ; then
218 dodoc "${DOCS[@]}"
219 else
220 dodoc ${DOCS}
221 fi
222 fi
78 223
79 # Do not keep /var/lib/scrollkeeper because: 224 # Do not keep /var/lib/scrollkeeper because:
80 # 1. scrollkeeper will get regenerated at pkg_postinst() 225 # 1. The scrollkeeper database is regenerated at pkg_postinst()
81 # 2. ${D}/var/lib/scrollkeeper contains only indexes for the current pkg 226 # 2. ${ED}/var/lib/scrollkeeper contains only indexes for the current pkg
82 # thus it makes no sense if pkg_postinst ISN'T run for some reason. 227 # thus it makes no sense if pkg_postinst ISN'T run for some reason.
83 228 rm -rf "${ED}${sk_tmp_dir}"
84 if [[ -z "$(find ${D} -name '*.omf')" ]]; then 229 rmdir "${ED}/var/lib" 2>/dev/null
85 export SCROLLKEEPER_UPDATE="0" 230 rmdir "${ED}/var" 2>/dev/null
86 fi
87
88 # Regenerate these in pkg_postinst()
89 rm -rf "${D}${SCROLLKEEPER_DIR}"
90 231
91 # Make sure this one doesn't get in the portage db 232 # Make sure this one doesn't get in the portage db
92 rm -fr "${D}/usr/share/applications/mimeinfo.cache" 233 rm -fr "${ED}/usr/share/applications/mimeinfo.cache"
93}
94 234
95 235 # Delete all .la files
96gnome2_gconf_install() { 236 if has ${EAPI:-0} 0 1 2 3 4; then
97 if [[ -x ${GCONFTOOL_BIN} ]]; then 237 if [[ "${GNOME2_LA_PUNT}" != "no" ]]; then
98 # We are ready to install the GCONF Scheme now 238 ebegin "Removing .la files"
99 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL 239 if ! { has static-libs ${IUSE//+} && use static-libs; }; then
100 export GCONF_CONFIG_SOURCE=$(${GCONFTOOL_BIN} --get-default-source) 240 find "${D}" -name '*.la' -exec rm -f {} + || die "la file removal failed"
101
102 einfo "Installing GNOME 2 GConf schemas"
103
104 local contents="${ROOT}/var/db/pkg/*/${PN}-${PVR}/CONTENTS"
105
106 for F in $(grep "obj /etc/gconf/schemas" ${contents} | sed 's:obj \([^ ]*\) .*:\1:' ); do
107 if [[ -e "${F}" ]]; then
108 # echo "DEBUG::gconf install ${F}"
109 ${GCONFTOOL_BIN} --makefile-install-rule ${F} 1>/dev/null
110 fi 241 fi
111 done
112 fi
113}
114
115gnome2_gconf_uninstall() {
116 if [[ -x ${GCONFTOOL_BIN} ]]; then
117 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
118 export GCONF_CONFIG_SOURCE=$(${GCONFTOOL_BIN} --get-default-source)
119
120 einfo "Uninstalling GNOME 2 GConf schemas"
121
122 local contents="${ROOT}/var/db/pkg/*/${PN}-${PVR}/CONTENTS"
123
124 for F in $(grep "obj /etc/gconf/schemas" ${contents} | sed 's:obj \([^ ]*\) .*:\1:' ); do
125 # echo "DEBUG::gconf install ${F}"
126 ${GCONFTOOL_BIN} --makefile-uninstall-rule ${F} 1>/dev/null
127 done
128 fi
129}
130
131gnome2_icon_cache_update() {
132 local updater=$(type -p gtk-update-icon-cache 2> /dev/null)
133
134 ebegin "Updating icons cache"
135
136 if [[ ! -x ${updater} ]] ; then
137 debug-print "${updater} is not executable"
138
139 # We failed to run
140 eend 1 242 eend
141
142 return
143 fi
144
145 if ! grep -q "obj /usr/share/icons" ${ROOT}/var/db/pkg/*/${PF}/CONTENTS
146 then
147 debug-print "No items to update"
148
149 # We are done successfully
150 eend 0
151
152 return
153 fi
154
155 local retval=0
156 local fails=( )
157
158 for dir in $(find ${ROOT}/usr/share/icons -maxdepth 1 -mindepth 1 -type d)
159 do
160 if [[ -f "${dir}/index.theme" ]] ; then
161 local rv=0
162
163 ${updater} -qf ${dir}
164 rv=$?
165
166 if [[ ! $rv -eq 0 ]] ; then
167 debug-print "Updating cache failed on ${dir}"
168
169 # Add to the list of failures
170 fails[$(( ${#fails[@]} + 1 ))]=$dir
171
172 retval=2
173 fi 243 fi
244 else
245 case "${GNOME2_LA_PUNT}" in
246 yes) prune_libtool_files --modules;;
247 no) ;;
248 *) prune_libtool_files;;
249 esac
174 fi 250 fi
175 done
176
177 eend ${retval}
178
179 for (( i = 0 ; i < ${#fails[@]} ; i++ )) ; do
180 eerror "Failed to update cache with icon ${fails[i]}"
181 done
182} 251}
183 252
184gnome2_omf_fix() { 253# @FUNCTION: gnome2_pkg_preinst
185 # workaround/patch against omf.make or omf-install/Makefile.in 254# @DESCRIPTION:
186 # in order to remove redundant scrollkeeper-updates. 255# Finds Icons, GConf and GSettings schemas for later handling in pkg_postinst
187 # - <liquidx@gentoo.org> 256gnome2_pkg_preinst() {
188 257 gnome2_gconf_savelist
189 local omf_makefiles filename 258 gnome2_icon_savelist
190 259 gnome2_schemas_savelist
191 omf_makefiles="$@" 260 gnome2_scrollkeeper_savelist
192
193 if [[ -f ${S}/omf-install/Makefile.in ]] ; then
194 omf_makefiles="${omf_makefiles} ${S}/omf-install/Makefile.in"
195 fi
196
197 # FIXME: does this really work? because omf.make only gets included
198 # when autoconf/automake is run. You should directly patch
199 # the Makefile.in's
200
201 if [[ -f ${S}/omf.make ]] ; then
202 omf_makefiles="${omf_makefiles} ${S}/omf.make"
203 fi
204
205 # testing fixing of all makefiles found
206 for filename in $(find ./ -name "Makefile.in" -o -name "Makefile.am") ; do
207 omf_makefiles="${omf_makefiles} ${filename}"
208 done
209
210 ebegin "Fixing OMF Makefiles"
211
212 local retval=0
213 local fails=( )
214
215 for omf in ${omf_makefiles} ; do
216 local rv=0
217
218 sed -i -e 's:scrollkeeper-update:true:' ${omf}
219 retval=$?
220
221 if [[ ! $rv -eq 0 ]] ; then
222 debug-print "updating of ${omf} failed"
223
224 # Add to the list of failures
225 fails[$(( ${#fails[@]} + 1 ))]=$omf
226
227 retval=2
228 fi
229 done
230
231 eend $retval
232
233 for (( i = 0 ; i < ${#fails[@]} ; i++ )) ; do
234 eerror "Failed to update OMF Makefile ${fails[i]}"
235 done
236} 261}
237 262
238gnome2_scrollkeeper_update() { 263# @FUNCTION: gnome2_pkg_postinst
239 if [[ -x ${SCROLLKEEPER_UPDATE_BIN} && "${SCROLLKEEPER_UPDATE}" = "1" ]] 264# @DESCRIPTION:
240 then 265# Handle scrollkeeper, GConf, GSettings, Icons, desktop and mime
241 einfo "Updating scrollkeeper database ..." 266# database updates.
242 ${SCROLLKEEPER_UPDATE_BIN} -q -p ${ROOT}${SCROLLKEEPER_DIR}
243 fi
244}
245
246gnome2_pkg_postinst() { 267gnome2_pkg_postinst() {
247 gnome2_gconf_install 268 gnome2_gconf_install
248 gnome2_scrollkeeper_update
249 fdo-mime_desktop_database_update 269 fdo-mime_desktop_database_update
250 fdo-mime_mime_database_update 270 fdo-mime_mime_database_update
251 gnome2_icon_cache_update 271 gnome2_icon_cache_update
272 gnome2_schemas_update
273 gnome2_scrollkeeper_update
252} 274}
253 275
276# # FIXME Handle GConf schemas removal
254#gnome2_pkg_prerm() { 277#gnome2_pkg_prerm() {
255# gnome2_gconf_uninstall 278# gnome2_gconf_uninstall
256#} 279#}
257 280
281# @FUNCTION: gnome2_pkg_postrm
282# @DESCRIPTION:
283# Handle scrollkeeper, GSettings, Icons, desktop and mime database updates.
258gnome2_pkg_postrm() { 284gnome2_pkg_postrm() {
259 gnome2_scrollkeeper_update
260 fdo-mime_desktop_database_update 285 fdo-mime_desktop_database_update
261 fdo-mime_mime_database_update 286 fdo-mime_mime_database_update
262 gnome2_icon_cache_update 287 gnome2_icon_cache_update
288 gnome2_schemas_update
289 gnome2_scrollkeeper_update
263} 290}
264
265EXPORT_FUNCTIONS src_unpack src_compile src_install pkg_postinst pkg_postrm

Legend:
Removed from v.1.63  
changed lines
  Added in v.1.119

  ViewVC Help
Powered by ViewVC 1.1.20